// Code generated by Kitex v1.9.3. DO NOT EDIT.

package deviceservice

import (
	"code.byted.org/kite/kitex/byted"
	"code.byted.org/kite/kitex/client"
	"code.byted.org/kite/kitex/client/callopt"
	"code.byted.org/libo.1220/libo.1220_api/kitex_gen/device_info"
	"context"
)

// Client is designed to provide IDL-compatible methods with call-option parameter for kitex framework.
type Client interface {
	GetDevice(ctx context.Context, request *device_info.GetDeviceRequest, callOptions ...callopt.Option) (r *device_info.DeviceResponse, err error)
	GetDeviceByIdentifiers(ctx context.Context, request *device_info.GetDeviceByIdentifiersRequest, callOptions ...callopt.Option) (r *device_info.DeviceResponse, err error)
	GetOrCreateDevice(ctx context.Context, request *device_info.CASDeviceRequest, callOptions ...callopt.Option) (r *device_info.GetOrCreateDeviceResponse, err error)
	CreateDevice(ctx context.Context, request *device_info.CASDeviceRequest, callOptions ...callopt.Option) (r *device_info.DeviceResponse, err error)
	UpdateDevice(ctx context.Context, request *device_info.UpdateDeviceRequest, callOptions ...callopt.Option) (r *device_info.DeviceResponse, err error)
	UpdateDeviceFull(ctx context.Context, request *device_info.UpdateDeviceFullRequest, callOptions ...callopt.Option) (r *device_info.DeviceResponse, err error)
	GetInstallation(ctx context.Context, request *device_info.GetInstallationRequest, callOptions ...callopt.Option) (r *device_info.InstallationResponse, err error)
	GetFullInstallation(ctx context.Context, request *device_info.GetInstallationRequest, callOptions ...callopt.Option) (r *device_info.FullInstallationResponse, err error)
	GetLatestInstallation(ctx context.Context, request *device_info.GetLatestInstallationRequest, callOptions ...callopt.Option) (r *device_info.InstallationResponse, err error)
	GetFirstInstallationByProductId(ctx context.Context, request *device_info.GetInstallationByProductIdRequest, callOptions ...callopt.Option) (r *device_info.InstallationResponse, err error)
	GetLatestInstallationByAppId(ctx context.Context, request *device_info.GetInstallationByAppIdRequest, callOptions ...callopt.Option) (r *device_info.InstallationResponse, err error)
	GetFirstInstallationByAppId(ctx context.Context, request *device_info.GetInstallationByAppIdRequest, callOptions ...callopt.Option) (r *device_info.InstallationResponse, err error)
	GetOrCreateInstallation(ctx context.Context, request *device_info.GetOrCreateInstallationRequest, callOptions ...callopt.Option) (r *device_info.GetOrCreateInstallationResponse, err error)
	CreateInstallation(ctx context.Context, request *device_info.CreateInstallationRequest, callOptions ...callopt.Option) (r *device_info.CreateInstallationResponse, err error)
	UpdateInstallationActivateTime(ctx context.Context, request *device_info.UpdateInstallationActivateTimeRequest, callOptions ...callopt.Option) (r *device_info.InstallationResponse, err error)
	UpdateInstallationLastTime(ctx context.Context, request *device_info.UpdateInstallationLastTimeRequest, callOptions ...callopt.Option) (r *device_info.InstallationResponse, err error)
	UpdateInstallationLanguageRegion(ctx context.Context, request *device_info.UpdateInstallationLanguageRegionRequest, callOptions ...callopt.Option) (r *device_info.InstallationResponse, err error)
	UpdateInstallation(ctx context.Context, request *device_info.UpdateInstallationRequest, callOptions ...callopt.Option) (r *device_info.InstallationResponse, err error)
	MGetFullInstalls(ctx context.Context, request *device_info.MGetFullInstallsRequest, callOptions ...callopt.Option) (r *device_info.MGetResponse, err error)
	MGetDevices(ctx context.Context, request *device_info.MGetDevicesRequest, callOptions ...callopt.Option) (r *device_info.MGetResponse, err error)
	GetSpecificChannel(ctx context.Context, request *device_info.GetSpecificChannelRequest, callOptions ...callopt.Option) (r *device_info.GetSpecificChannelResponse, err error)
	UpdateSpecificChannel(ctx context.Context, request *device_info.UpdateSpecificChannelRequest, callOptions ...callopt.Option) (r *device_info.UpdateSpecificChannelResponse, err error)
	GetDeviceByMarks(ctx context.Context, request *device_info.GetDeviceByMarksRequest, callOptions ...callopt.Option) (r *device_info.DeviceResponse, err error)
	GetProductAppByMarks(ctx context.Context, request *device_info.GetProductAppByMarksRequest, callOptions ...callopt.Option) (r *device_info.ProductAppResponse, err error)
}

// NewClient creates a client for the service defined in IDL.
func NewClient(destService string, opts ...client.Option) (Client, error) {
	var options []client.Option
	options = append(options, client.WithDestService(destService))

	config := byted.NewClientConfig()
	config.DestService = destService

	options = append(options, byted.ClientSuiteWithConfig(serviceInfo(), config))

	options = append(options, opts...)

	kc, err := client.NewClient(serviceInfo(), options...)
	if err != nil {
		return nil, err
	}
	return &kDeviceServiceClient{
		kClient: newServiceClient(kc),
	}, nil
}

// MustNewClient creates a client for the service defined in IDL. It panics if any error occurs.
func MustNewClient(destService string, opts ...client.Option) Client {
	kc, err := NewClient(destService, opts...)
	if err != nil {
		panic(err)
	}
	return kc
}

type kDeviceServiceClient struct {
	*kClient
}

func (p *kDeviceServiceClient) GetDevice(ctx context.Context, request *device_info.GetDeviceRequest, callOptions ...callopt.Option) (r *device_info.DeviceResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.GetDevice(ctx, request)
}

func (p *kDeviceServiceClient) GetDeviceByIdentifiers(ctx context.Context, request *device_info.GetDeviceByIdentifiersRequest, callOptions ...callopt.Option) (r *device_info.DeviceResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.GetDeviceByIdentifiers(ctx, request)
}

func (p *kDeviceServiceClient) GetOrCreateDevice(ctx context.Context, request *device_info.CASDeviceRequest, callOptions ...callopt.Option) (r *device_info.GetOrCreateDeviceResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.GetOrCreateDevice(ctx, request)
}

func (p *kDeviceServiceClient) CreateDevice(ctx context.Context, request *device_info.CASDeviceRequest, callOptions ...callopt.Option) (r *device_info.DeviceResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.CreateDevice(ctx, request)
}

func (p *kDeviceServiceClient) UpdateDevice(ctx context.Context, request *device_info.UpdateDeviceRequest, callOptions ...callopt.Option) (r *device_info.DeviceResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.UpdateDevice(ctx, request)
}

func (p *kDeviceServiceClient) UpdateDeviceFull(ctx context.Context, request *device_info.UpdateDeviceFullRequest, callOptions ...callopt.Option) (r *device_info.DeviceResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.UpdateDeviceFull(ctx, request)
}

func (p *kDeviceServiceClient) GetInstallation(ctx context.Context, request *device_info.GetInstallationRequest, callOptions ...callopt.Option) (r *device_info.InstallationResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.GetInstallation(ctx, request)
}

func (p *kDeviceServiceClient) GetFullInstallation(ctx context.Context, request *device_info.GetInstallationRequest, callOptions ...callopt.Option) (r *device_info.FullInstallationResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.GetFullInstallation(ctx, request)
}

func (p *kDeviceServiceClient) GetLatestInstallation(ctx context.Context, request *device_info.GetLatestInstallationRequest, callOptions ...callopt.Option) (r *device_info.InstallationResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.GetLatestInstallation(ctx, request)
}

func (p *kDeviceServiceClient) GetFirstInstallationByProductId(ctx context.Context, request *device_info.GetInstallationByProductIdRequest, callOptions ...callopt.Option) (r *device_info.InstallationResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.GetFirstInstallationByProductId(ctx, request)
}

func (p *kDeviceServiceClient) GetLatestInstallationByAppId(ctx context.Context, request *device_info.GetInstallationByAppIdRequest, callOptions ...callopt.Option) (r *device_info.InstallationResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.GetLatestInstallationByAppId(ctx, request)
}

func (p *kDeviceServiceClient) GetFirstInstallationByAppId(ctx context.Context, request *device_info.GetInstallationByAppIdRequest, callOptions ...callopt.Option) (r *device_info.InstallationResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.GetFirstInstallationByAppId(ctx, request)
}

func (p *kDeviceServiceClient) GetOrCreateInstallation(ctx context.Context, request *device_info.GetOrCreateInstallationRequest, callOptions ...callopt.Option) (r *device_info.GetOrCreateInstallationResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.GetOrCreateInstallation(ctx, request)
}

func (p *kDeviceServiceClient) CreateInstallation(ctx context.Context, request *device_info.CreateInstallationRequest, callOptions ...callopt.Option) (r *device_info.CreateInstallationResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.CreateInstallation(ctx, request)
}

func (p *kDeviceServiceClient) UpdateInstallationActivateTime(ctx context.Context, request *device_info.UpdateInstallationActivateTimeRequest, callOptions ...callopt.Option) (r *device_info.InstallationResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.UpdateInstallationActivateTime(ctx, request)
}

func (p *kDeviceServiceClient) UpdateInstallationLastTime(ctx context.Context, request *device_info.UpdateInstallationLastTimeRequest, callOptions ...callopt.Option) (r *device_info.InstallationResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.UpdateInstallationLastTime(ctx, request)
}

func (p *kDeviceServiceClient) UpdateInstallationLanguageRegion(ctx context.Context, request *device_info.UpdateInstallationLanguageRegionRequest, callOptions ...callopt.Option) (r *device_info.InstallationResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.UpdateInstallationLanguageRegion(ctx, request)
}

func (p *kDeviceServiceClient) UpdateInstallation(ctx context.Context, request *device_info.UpdateInstallationRequest, callOptions ...callopt.Option) (r *device_info.InstallationResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.UpdateInstallation(ctx, request)
}

func (p *kDeviceServiceClient) MGetFullInstalls(ctx context.Context, request *device_info.MGetFullInstallsRequest, callOptions ...callopt.Option) (r *device_info.MGetResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.MGetFullInstalls(ctx, request)
}

func (p *kDeviceServiceClient) MGetDevices(ctx context.Context, request *device_info.MGetDevicesRequest, callOptions ...callopt.Option) (r *device_info.MGetResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.MGetDevices(ctx, request)
}

func (p *kDeviceServiceClient) GetSpecificChannel(ctx context.Context, request *device_info.GetSpecificChannelRequest, callOptions ...callopt.Option) (r *device_info.GetSpecificChannelResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.GetSpecificChannel(ctx, request)
}

func (p *kDeviceServiceClient) UpdateSpecificChannel(ctx context.Context, request *device_info.UpdateSpecificChannelRequest, callOptions ...callopt.Option) (r *device_info.UpdateSpecificChannelResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.UpdateSpecificChannel(ctx, request)
}

func (p *kDeviceServiceClient) GetDeviceByMarks(ctx context.Context, request *device_info.GetDeviceByMarksRequest, callOptions ...callopt.Option) (r *device_info.DeviceResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.GetDeviceByMarks(ctx, request)
}

func (p *kDeviceServiceClient) GetProductAppByMarks(ctx context.Context, request *device_info.GetProductAppByMarksRequest, callOptions ...callopt.Option) (r *device_info.ProductAppResponse, err error) {
	ctx = client.NewCtxWithCallOptions(ctx, callOptions)
	return p.kClient.GetProductAppByMarks(ctx, request)
}

// NewClientWithBytedConfig creates a client for the service defined in IDL.
func NewClientWithBytedConfig(destService string, config *byted.ClientConfig, opts ...client.Option) (Client, error) {
	if config == nil {
		config = byted.NewClientConfig()
	}
	config.DestService = destService

	var options []client.Option
	options = append(options, client.WithDestService(destService))

	options = append(options, byted.ClientSuiteWithConfig(serviceInfo(), config))
	options = append(options, opts...)
	kc, err := client.NewClient(serviceInfo(), options...)
	if err != nil {
		return nil, err
	}
	return &kDeviceServiceClient{
		kClient: newServiceClient(kc),
	}, nil
}

// MustNewClientWithBytedConfig creates a client for the service defined in IDL. It panics if any error occurs.
func MustNewClientWithBytedConfig(destService string, config *byted.ClientConfig, opts ...client.Option) Client {
	kc, err := NewClientWithBytedConfig(destService, config, opts...)
	if err != nil {
		panic(err)
	}
	return kc
}
